

import json

class Action:
    # SendText: str = 'send_text'
    # SendFile: str = 'send_file'

    RequestFile: str = 'request_file'
    ResponseOneFileInfo: str = 'response_one_file'
    ResponseOneFileComplete: str = 'response_one_file_comp'
    ResponseAllFilesComplete: str = 'response_all_files_comp'

    GetInfo: str = 'get_info'

    Complete: str = 'complete'

class Msg:

    action: str
    params: list
  
    def __init__(self, action: str, params: list) -> None:
        self.action = action
        self.params = params
        pass

    @classmethod
    def fromBytes(cls, data: bytes):
        try:
            string = data.decode(encoding='UTF-8', errors='strict')
            obj = json.loads(string)
            return Msg(obj['action'], obj['params'])
        except Exception as e:
            print(e)
            raise Exception("data format error")

    def toBytes(self) -> bytes:
        return self.toString().encode(encoding='UTF-8', errors='strict')

    def toString(self) -> str:
        obj = {
            'action': self.action,
            'params': self.params,
        }
        return json.dumps(obj)